{{- /*
SPDX-License-Identifier: EUPL-1.2
*/}}

{{- range $type, $range := (dict "station" .Values.stations "worker" .Values.workers ) }}
{{- range $name, $entity := $range }}
{{- $component := print $type "." $name }}
{{- $pdb := default $.Values.pdb .pdb }}
{{- $commonLabels := default $.Values.commonLabels .commonLabels }}
{{- $commonAnnotations := default $.Values.commonAnnotations .commonAnnotations }}
{{- $podLabels := default $.Values.podLabels .podLabels }}
{{- if $pdb.create }}
apiVersion: {{ include "common.capabilities.policy.apiVersion" $ }}
kind: PodDisruptionBudget
metadata:
  name: {{ template "common.names.fullname" $ }}-{{ $type }}-{{ $name }}
  namespace: {{ include "common.names.namespace" $ | quote }}
  labels: {{- include "common.labels.standard" ( dict "customLabels" $commonLabels "context" $ ) | nindent 4 }}
  {{- if $commonAnnotations }}
  annotations: {{- include "common.tplvalues.render" ( dict "value" $commonAnnotations "context" $ ) | nindent 4 }}
  {{- end }}
spec:
  {{- if $pdb.minAvailable }}
  minAvailable: {{ $pdb.minAvailable }}
  {{- end }}
  {{- if or $pdb.maxUnavailable (not $pdb.minAvailable)}}
  maxUnavailable: {{ $pdb.maxUnavailable | default 1 }}
  {{- end }}
  {{- $mergedPodLabels := include "common.tplvalues.merge" ( dict "values" ( list $podLabels $commonLabels ) "context" $ ) }}
  selector:
    matchLabels: 
      {{- include "common.labels.matchLabels" ( dict "customLabels" $mergedPodLabels "context" $ ) | nindent 6 }}
      app.kubernetes.io/component: {{ $component }}
---
{{- end }}
{{- end }}
{{- end }}
